RADIX 16
COMMENT @
This assembly language routine, used in read_absolute, when converted 
to Inline code to be included with Turbo Pascal 3.0, replaces the Intr 
Turbo Pascal function when using the absolute disk read, interrupt 
$25.  There must be ONLY ONE local variable declared, and that must be 
of type register (record type used with Intr and MsDos).  (This cludge 
is very specific for this procedure.)  Instead of the carry flag 
registering an error, the variable ERROR (boolean) is modified 
directly.  This is VERY non-standard, but then, this is not exactly a 
standard problem.  (This was done before I discovered that Int $25 
trashes the BP register, and there would be more debugging time 
involved if I went through and changed everything back.)

This is my first real attempt at assembly code, and with the Turbo 
Pascal interface, no less.  I have spent many hours on the many 
different versions of this code, but it has been a real learning 
experience.   If it works, it works, and I am not worried about a few 
(or a lot of) clock cycles that could be saved.

This file has to be assembled, converted to a .COM file, and then 
converted to Inline code.  (I used a program called INLINE.PAS to do 
the converting, rather than entering all of the hex data by hand).
@                       

begin:
push ax  ; save every register...
push bx
push cx
push dx
push bp
push si
push di
push ds
push es

push bp       

mov ax,[bp-16]
mov bx,[bp-14]  ; move values from regs record to registers
mov cx,[bp-12]
mov dx,[bp-10]
; mov bp,[bp-0e]       ; DON'T TOUCH BP!!!!
; mov si,[bp-0c]
; mov di,[bp-0a]
mov ds,[bp-08]
; mov es,[bp-06]
                ; don't write to flags, since they are unimportant
                ; for what we are doing here...
                ; here do the interrupt... 
int 25          ; read in the sectors...
jc error        ; error?
pop dx          ; no, get rid of flag...

pop bp

push ax         ;
les di,[bp+0c]  ; SET ERROR manually...
mov ax,0        ; 
mov es:[di],al  ; 
pop ax          ;
               
jmp goback      ; and begin the return trip...

error:
pop dx          ; yes, get rid of flags 
                 
pop bp          ; return BP so we can return registers back to the
                ; regs record...
push ax         ;
les di,[bp+0c]  ; SET ERROR manually...
mov ax,1        ; 
mov es:[di],al  ; 
pop ax          ;

goback:                 ; lets go home...
mov [bp-16],ax          ; move registers back to regs record 
mov [bp-14],bx          
mov [bp-12],cx
mov [bp-10],dx
; mov [bp-0e],bp        ; DON'T EVEN TOUCH BP!
; mov [bp-0c],si
; mov [bp-0a],di
; mov [bp-08],ds
; mov [bp-06],es

pop es              ; restore the stack
pop ds
pop di
pop si
pop bp
pop dx
pop cx         
pop bx
pop ax
; finished finally...the computer's stack is 
; probably pleading for mercy by now... 

