program vaccine;

const
  title = 'Anti-Brain Vaccine';
  author = '(c) by Duane Brown';
  version = 'version 1.10, February 21, 1988';

  bad_cluster = $ff7; { decimal 4087 }
  copies_of_fat = 2;  { constant for all types of disk }
  min_cluster = 2;    { constant for all types of disk }
  S9 = $fc; D9 = $fd; S8 = $fe; D8 = $ff; { types of disk defined for us }

type
  t_regpack =
  record
    ax,bx,cx,dx,bp,si,di,ds,es,flags: integer;
  END;

  string60 = string[60];
  sec_type = array[0..511] of char;

  fat_cluster_type = array[0..355] of integer; { max cluster for us is 355 }
  fat_type = array[0..2047] of byte; { max # of bytes in whole FAT }
  dir_type = array[1..7] of sec_type; { max # of directory sectors }

  boot_type = sec_type;

var
  memory_size_in_K : integer absolute $0:$0413; {total memory size in K }
  virus_in_ram : boolean;
  cmd_line_parms : boolean;
  boot : boot_type;
  dir : dir_type;
  fat_org : fat_type;
  fat_org_count : integer;
  fat_count : integer;
  boot_inf, dir_inf, fat_inf : boolean;

  disk_description : array[S9..D8] of string60;

  boot_sect_number, boot_sect_length, fat_sect_number: array[S9..D8] of integer;
  fat_sect_length, dir_sect_number, dir_sect_length: array[S9..D8] of integer;
  sect_per_cluster, max_cluster : array[S9..D8] of integer;

  drv : char;
  drive, drive1 : INTEGER;
  dtype : integer;
  fat : fat_cluster_type;
  fe1,fe2 : INTEGER;
  i, j: INTEGER;
  c   : real;
  first_bad_cluster : integer;
  disk_error : array[1..3] of boolean;
  rom_error, dos_error : array[1..3] of byte;
  t_sect : sec_type;
  found : boolean;
  entry : integer;
  dir_sector_where_found: integer;
  ch : char;
  color : boolean;

{ -------------------------------------------------------------------- }

PROCEDURE getkey (var ch: char);
BEGIN
   repeat
   read(KBD,ch);
   until ch <> '';
ch := upcase(ch);
END;

{ ------------------------------------------------------------------- }

PROCEDURE changetextcolor(c : integer);
{ Depending on whether color is selected, change textcolor to the
  specified color }

BEGIN
   if color then
      textcolor(c);
END;

{ ------------------------------------------------------------------- }


PROCEDURE changetextbackground(c : integer);
{ Depending on whether color is selected, change textbackgroundcolor to the
  specified color }

BEGIN
   if color then
      textbackground(c);
END;

{ ------------------------------------------------------------------- }

PROCEDURE is_virus_present(var error : boolean);
{ This procedure determines if the virus is in memory by taking the amount
  of memory acording to the boot up routines, and testing if 7K is missing }

var
   x : integer;

BEGIN
   x := memory_size_in_K + 7;    { virus takes up 7K in RAM from start   }
   if (x div 16) = (x / 16) then { memory is only allocated in PC's on   }
      BEGIN                      { EVEN 16K-byte boundaries (so test for }
      error := true;             { even-ness by dividing by 16...if true }
      END                        { current memory + 7 is divisible by 16,}
   else                          { then 7K has been taken away and the   }
      error := false;            { virus is present in memory...         }
END;

{ ------------------------------------------------------------------- }

PROCEDURE Header;
BEGIN
writeln('Do you want color? ');
getkey(ch);
if (ch = 'Y') then
   color := true
else
   color := false;
writeln;
changetextbackground(blue);
changetextcolor(white);
clrscr;
writeln(title + ' ' + version);
writeln(author);
writeln;
changetextcolor(yellow);
write('Do you need help (Y/N)? ');
getkey(ch);
if (ch = 'Y') then
BEGIN
   changetextcolor(cyan);
   writeln;
   writeln;
   writeln('Usage:  VACCINE [d:]');
   writeln;
   writeln(' d: represents the optional disk drive to be examined.');
   writeln;
   writeln('   This program detects, and optionally, gets rid of, the (c) Brain');
   writeln('virus that has spread virluently around the country.  Reports exist that');
   writeln('state that it is harmless.  Although these may or may not be true, the');
   writeln('virus DOES take up 7K of system RAM, and 3K of your valuable disk space.');
   writeln;
   writeln('   Either way, this program erases the virus from your disks, and detects');
   writeln('if the virus is in memory now.  The process should be totally automatic,');
   writeln('but you should have a valid DOS disk (one that does not have the virus) handy.');
   writeln;
   writeln('   This program only supports 5 1/4" disks.  The virus only replicates');
   writeln('itself on double sided, 9 sector per track diskettes (360K disks).  It');
   writeln('does not copy itself on any other type of disk that I know of, possibly');
   writeln('including hard disks.  The carrier of the program is still unknown.');
   writeln;
   writeln('   Details of the operation of the vaccine can be found in the documentation');
   writeln('accompanying this program.');
   writeln;
   changetextcolor(lightgreen);
   writeln('Press any key to begin program.');
   getkey(ch);
END;
writeln;
textcolor(yellow);
writeln('First things first, let`s see if the virus is currently in memory: ');
is_virus_present(virus_in_ram);
writeln;
if virus_in_ram then BEGIN
   changetextcolor(white+blink);
   writeln;
   write(^G^G^G'THE VIRUS IS CURRENTLY IN MEMORY!');
   changetextcolor(white);
   writeln('  Please REBOOT with an uninfected disk');
   writeln('AS SOON AS POSSIBLE (now would be a good time...).  You may continue');
   writeln('with this program, but realize that YOU WILL BE SPREADING THE VIRUS as');
   write('long as you test un-write protected disks...');
   changetextcolor(white+blink);
   writeln('YOU HAVE BEEN WARNED!!');
   changetextcolor(white);
   END
else
   writeln('The virus is not in memory now.  You may continue virus killing safely.');

END;

{ ------------------------------------------------------------------- }

PROCEDURE init_constants;
{ Initializes the disk id parameters -- uses global arrays }

var
   i : integer;

BEGIN

   for i := S9 to D8 do BEGIN { params that are same for all disk types }
      boot_sect_number[i] := 0;
      boot_sect_length[i] := 1;
   END;

   fat_sect_length[S8] := 2; dir_sect_length[S8] := 4;
   fat_sect_length[D8] := 2; dir_sect_length[D8] := 7;
   fat_sect_length[S9] := 4; dir_sect_length[S9] := 4;
   fat_sect_length[D9] := 4; dir_sect_length[D9] := 7;

   for i := S9 to D8 do { now calucalate the beginning sectors, given
                          { the lengths of FAT and DIR sectors }
       BEGIN
       fat_sect_number[i] := boot_sect_number[i] + boot_sect_length[i];
       dir_sect_number[i] := fat_sect_number[i] + fat_sect_length[i];
       END;

   sect_per_cluster[S9] := 1;
   sect_per_cluster[D9] := 2;
   sect_per_cluster[S8] := 1;
   sect_per_cluster[D9] := 2;

   max_cluster[S9] := 352;
   max_cluster[D9] := 355;
   max_cluster[S8] := 314;
   max_cluster[D8] := 316;

   disk_description[S9] := 'single sided and has 9 sectors per track (180K)';
   disk_description[D9] := 'double sided and has 9 sectors per track (360K)';
   disk_description[S8] := 'single sided and has 8 sectors per track (160K)';
   disk_description[D8] := 'double sided and has 8 sectors per track (320K)';

END; { of procedure }

{ ------------------------------------------------------------------- }


FUNCTION cluster_to_sector (cluster : integer): integer;
{ Given a cluster, calculates the sector number (for use with absolute
  read/write }

BEGIN
    cluster_to_sector := (boot_sect_length[dtype] + fat_sect_length[dtype] +
                          dir_sect_length[dtype]) + (cluster - min_cluster) *
                          sect_per_cluster[dtype];
END;

{ ------------------------------------------------------------------- }

FUNCTION drvlett(drive: integer) : char;
{ return drive letter of drive number (drive) }

BEGIN
   drvlett := char(ord('A') + drive);
END;

{ ------------------------------------------------------------------- }

PROCEDURE evaluate_error(drive : integer; rom, dos : byte;
                         startsec, numsec : integer);

{ This procedure evaluates any errors by Read or Write Absolute.  If the
  error is defined (i.e. drive door open), a message is printed, and the
  program is halted.  Otherwise, the two error codes are printed to the
  screen, and the program is halted.  Either way, the program is not
  returned to. }

BEGIN
  changetextcolor(brown);
  writeln('Error report: ');
  write('Parameters: drive, startsec, numsec: ',drive,', ',startsec,', ');
  writeln(numsec,'.');
  writeln;

  if (rom = 3) and (dos = 0) then BEGIN
     writeln('Disk in drive ',drvlett(drive),' is write protected.');
     halt;
     END;
  if (rom = 128) and (dos = 2) then BEGIN
     write('Drive door of drive ',drvlett(drive),' is open or no disk');
     writeln(' is inserted.');
     halt;
     END;
  writeln('Unknown error codes:  rom: ',rom, ' and dos: ',dos,'.');
  halt;
END;

{ ------------------------------------------------------------------- }

PROCEDURE Con_fat(b1,b2,b3: BYTE; VAR f1,f2: INTEGER);

BEGIN
 f1:= 0;
 f2:= 0;
 f1:= f1 + ((b2 MOD 16) * 256) + b1;
 f2:= f2 + (b3 * 16) + (b2 DIV 16);
END;

{ ------------------------------------------------------------------- }

PROCEDURE fat_con(VAR b1,b2,b3: BYTE; f1,f2: INTEGER);

BEGIN
 b1:= lo(f1);
 b2:= hi(f1) + ((f2 MOD 16) * 16);
 b3:= (f2 DIV 16);
END;

{ ------------------------------------------------------------------- }

PROCEDURE change_fat(cluster, new_value : integer;
                     var cluster_array : fat_cluster_type;
                     var fat_array : fat_type );

{ This procedure changes the given FAT entry to new_value, by changing
  the value of the cluster entry in cluster_array, and then converting
  that value into the fat_array }

var
   clust_temp : integer;
   cluster_begin : integer;
   fat_begin : integer;
BEGIN
   clust_temp := cluster;                   { Find actual cluster offset }
   cluster_array[clust_temp] := new_value;  { we need two values for con_fat }
   cluster_begin := clust_temp div 2;       { find lowest common denominator }
   fat_begin := cluster_begin * 3;          { to find FAT array offset }

  fat_con(fat_array[fat_begin],fat_array[fat_begin+1],fat_array[fat_begin+2],
          cluster_array[cluster_begin * 2],cluster_array[cluster_begin*2 + 1]);
END;  { That be it }


{ ------------------------------------------------------------------- }

PROCEDURE read_absolute(drive, startsec, numsec : integer;
                        var buffer ;
                        var error : boolean;
                        var rom_err, dos_err : byte );

var
    regs : t_regpack;
BEGIN
    regs.ax := drive;
    regs.cx := numsec;
    regs.dx := startsec;
    regs.ds := seg(buffer);
    regs.bx := ofs(buffer);

    Inline($50/$53/$51/$52/$55/$56/$57/$1E/$06/$55/$8B/$46/$EA/$8B/$5E/$EC/
          $8B/$4E/$EE/$8B/$56/$F0/$8E/$5E/$F8/$CD/$25/$72/$10/$5A/$5D/$50/
          $C4/$7E/$0C/$B8/$00/$00/$26/$88/$05/$58/$E9/$0D/$00/$5A/$5D/$50/
          $C4/$7E/$0C/$B8/$01/$00/$26/$88/$05/$58/$89/$46/$EA/$89/$5E/$EC/
          $89/$4E/$EE/$89/$56/$F0/$07/$1F/$5F/$5E/$5D/$5A/$59/$5B/$58);

    if (error = true) then
    BEGIN
       rom_err := hi(regs.ax);
       dos_err := lo(regs.ax);
    END
    else
    BEGIN
       rom_err := 0;
       dos_err := 0;
    END
END;

{ ------------------------------------------------------------------- }

PROCEDURE read_boot(drive : integer; var temp_sect : sec_type) ;

{ This procedure reads the boot sector of the specified drive into temp_sect.}
var
   error : boolean;
   rom, dos : byte;

BEGIN
   read_absolute (drive, boot_sect_number[dtype], boot_sect_length[dtype],
                  temp_sect, error, rom, dos);
if error then
   evaluate_error(drive, rom, dos, boot_sect_number[dtype],
                  boot_sect_length[dtype]);
END;

{ ------------------------------------------------------------------- }

PROCEDURE write_absolute(drive, startsec, numsec : integer;
                        var buffer ;
                        var error : boolean;
                        var rom_err, dos_err : byte );

var
    regs : t_regpack;
BEGIN
    regs.ax := drive;
    regs.cx := numsec;
    regs.dx := startsec;
    regs.ds := seg(buffer);
    regs.bx := ofs(buffer);

    Inline($50/$53/$51/$52/$55/$56/$57/$1E/$06/$55/$8B/$46/$EA/$8B/$5E/$EC/
           $8B/$4E/$EE/$8B/$56/$F0/$8E/$5E/$F8/$CD/$26/$72/$10/$5A/$5D/$50/
           $C4/$7E/$0C/$B8/$00/$00/$26/$88/$05/$58/$E9/$0D/$00/$5A/$5D/$50/
           $C4/$7E/$0C/$B8/$01/$00/$26/$88/$05/$58/$89/$46/$EA/$89/$5E/$EC/
           $89/$4E/$EE/$89/$56/$F0/$07/$1F/$5F/$5E/$5D/$5A/$59/$5B/$58);

    if (error = true) then
    BEGIN
       rom_err := hi(regs.ax);
       dos_err := lo(regs.ax);
    END
    else
    BEGIN
       rom_err := 0;
       dos_err := 0;
    END
END;

{ ------------------------------------------------------------------- }

PROCEDURE test_sect(drive, sector : integer; var error : boolean;
                        var rom, dos : byte ) ;

{ This procedure reads the chosen sector of the specified drive into temp_sect
  to verify that it reads correctly. }
var
   temp_sect : sec_type;
BEGIN
   read_absolute (drive, sector, 1, temp_sect, error, rom, dos);
END;

{ ------------------------------------------------------------------- }

PROCEDURE read_fat(drive : integer; var temp_sect : fat_type ) ;

{ This procedure reads the FAT sectors into temp_sect.}
var
   error : boolean;
   rom, dos : byte;

BEGIN
   read_absolute (drive, fat_sect_number[dtype], fat_sect_length[dtype],
                  temp_sect, error, rom, dos);
if error then
   evaluate_error(drive, rom, dos, fat_sect_number[dtype],
                  fat_sect_length[dtype]);
END;

{ ------------------------------------------------------------------- }

PROCEDURE write_fat(drive : integer; var temp_sect : fat_type ) ;

{ This procedure writes the FAT sectors from temp_sect.}
var
   error : boolean;
   rom, dos : byte;

BEGIN

   write_absolute (drive, fat_sect_number[dtype], fat_sect_length[dtype],
                  temp_sect, error, rom, dos);
if error then
   evaluate_error(drive, rom, dos, fat_sect_number[dtype],
                  fat_sect_length[dtype]);
END;

{ ------------------------------------------------------------------- }

PROCEDURE write_boot(drive : integer; var temp_sect : sec_type) ;

{ This procedure writes to the boot sector of the specified drive in temp_sect.}
var
   error : boolean;
   rom, dos : byte;

BEGIN
   write_absolute (drive, boot_sect_number[dtype], boot_sect_length[dtype],
                   temp_sect, error, rom, dos);
if error then
   evaluate_error(drive, rom, dos, boot_sect_number[dtype],
                  boot_sect_length[dtype]);
END;

{ ------------------------------------------------------------------- }

PROCEDURE read_dir(drive : integer; var temp_sect : dir_type ) ;

{ This procedure reads the directory sectors into temp_sect.}
var
   error : boolean;
   rom, dos : byte;

BEGIN
   read_absolute (drive, dir_sect_number[dtype], dir_sect_length[dtype],
                  temp_sect, error, rom, dos);
if error then
   evaluate_error(drive, rom, dos, dir_sect_number[dtype],
                  dir_sect_length[dtype]);
END;

{ ------------------------------------------------------------------- }

PROCEDURE write_dir(drive : integer; var temp_sect : dir_type ) ;

{ This procedure writes the directory sectors from temp_sect.}
var
   error : boolean;
   rom, dos : byte;

BEGIN
   write_absolute (drive, dir_sect_number[dtype], dir_sect_length[dtype],
                  temp_sect, error, rom, dos);
if error then
   evaluate_error(drive, rom, dos, dir_sect_number[dtype],
                  dir_sect_length[dtype]);
END;

{ ------------------------------------------------------------------- }

 PROCEDURE get_disk_type (Drive:integer; var disk_type: integer);

var
   regs : t_regpack;

BEGIN
   with regs do
      BEGIN
      ax := $1c SHL 8;        { ah = code to get info from FAT }
      dx := drive + 1;        { drive number }
   END;
   MsDos(regs);
   disk_type := mem[regs.ds:regs.bx];
   END;

{ ------------------------------------------------------------------- }

PROCEDURE find_brain (dir_sector : sec_type ; var dir_found : boolean;
                      var dir_entry : integer );
{ This procedure scans the dir_sector array[index] for the brain label,
  and if it is found, reports the directory entry that it inhabits. }

var
   i, j : integer;
BEGIN
   dir_found := false;
   dir_entry := 0;  { can be equal to any integer from 0 to 15 }
      for j := 0 to 15 do
      BEGIN
         if((dir_sector[j*32]   = ' ') and
            (dir_sector[j*32+1] = '(') and
            (dir_sector[j*32+2] = 'c') and
            (dir_sector[j*32+3] = ')') and
            (dir_sector[j*32+4] = ' ') and
            (dir_sector[j*32+5] = 'B') and
            (dir_sector[j*32+6] = 'r') and
            (dir_sector[j*32+7] = 'a') and
            (dir_sector[j*32+8] = 'i') and
            (dir_sector[j*32+9] = 'n') and
            (dir_sector[j*32+10]= ' ') and
            (dir_sector[j*32+11]= char(8))) then
            BEGIN
                dir_found := true;
                dir_entry := j;
            END;
      END; { for j = 0 to 15 }
END;  { whole procedure }

{ \/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\ }
{ -----    T H E   M A I N   C O D E   ( F I N A L L Y )     -------- }
{ /\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/ }

BEGIN
Header;
init_constants;
cmd_line_parms := false;
drive := -1;
drive1 := 1 ; { the A drive is default... }
if (paramcount >= 1) and (not cmd_line_parms) then
   BEGIN
   cmd_line_parms := true;
   drive := ord(upcase(copy(paramstr(1),1,1))) - ord('A');
   END;


while (true) do BEGIN
 writeln;
 drive := -1;
 while (drive < 0) or (drive > 2) do
 BEGIN
    if not cmd_line_parms then
       BEGIN
       changetextcolor(yellow);
       write('Type drive name to remove virus from (space bar = ',drvlett(drive1));
       write(', Q to quit) ? '); getkey(drv);
       writeln(drv);
       drive := ord(upcase(drv)) - ord('A');
       END
    else
       cmd_line_parms := false;

    if drv = ' ' then
       BEGIN
       drv := drvlett(drive1);
       drive := drive1;
       END;

    if (drv = 'Q') then
       halt;

END;
writeln;

drive1 := drive;  { drive1 stores the original value... }

 get_disk_type(drive, dtype);
 if dtype in [S9..D8] then
    BEGIN
    writeln;
    changetextcolor(lightred);
    writeln('Disk in drive ',drvlett(drive),' is ',disk_description[dtype]);
    changetextcolor(yellow);
    if dtype in [S8, D8, S9] then
       BEGIN
       changetextcolor(white);
       write('This type of disk is not infected by the virus, but I''ll check');
       writeln(' it out anyway...');
       END;
    writeln;
    END
else
    BEGIN
    changetextcolor(white);
    writeln('That type of disk (ID number ',dtype,') is not supported in this version.');
    changetextcolor(yellow);
    halt;
    END;


{ ******************************************************************** }

 changetextcolor(lightcyan);
 write('Is the boot sector infected? . . . . . . . . . . . . . . . ');

 read_boot(drive, boot);

 boot_inf := false;
 if (boot[0]=char($FA)) and (boot[1]=char($E9)) and (boot[2]=char($4A)) then
    BEGIN
       boot_inf := true;
    END;
if boot_inf then
   BEGIN
   changetextcolor(white+blink);
   writeln('YES!');
   changetextcolor(lightcyan);
   END
else
   BEGIN
   writeln('NO!');
   END;

{ ******************************************************************** }

 { Now, load up the FAT and examine it }

  read_fat(drive,fat_org);

 { Decode it... }

 write('Is the FAT infected? . . . . . . . . . . . . . . . . . . . ');

 fat_inf := false;

 fat_count := 0;
 fat_org_count := 0;
 while fat_count <= max_cluster[dtype] do
 BEGIN
    con_fat(fat_org[fat_org_count],fat_org[fat_org_count+1],
            fat_org[fat_org_count+2],fe1,fe2);
    fat[fat_count] := fe1; fat[fat_count+1] := fe2;
    fat_count := fat_count + 2;
    fat_org_count := fat_org_count + 3;
 END;

 { Analyze it... }

 for i := 0 to max_cluster[dtype] - 3 do BEGIN
    if (fat[i] = bad_cluster) and (fat[i+1] = bad_cluster) and
        (fat[i+2] = bad_cluster) then BEGIN
        for j := i to i+2 do BEGIN
           test_sect(drive, cluster_to_sector(j),disk_error[j-i+1],
                        dos_error[j-i+1],rom_error[j-i+1]);
            END;
        if (not disk_error[1]) and (not disk_error[2]) and (not disk_error[3])
           then
           BEGIN
           first_bad_cluster := i;
           { 3 consecutive bad sectors found in fat that read GOOD!, so... }
           read_absolute(drive, cluster_to_sector(first_bad_cluster)+1,
                         1, t_sect, disk_error[1], rom_error[1], dos_error[1]);
           { Test for signature in second sector of the clusters }
           if (t_sect[0]=char($EB)) and (t_sect[1]=char($26)) and
              (t_sect[2]=char($28)) then BEGIN
              changetextcolor(white+blink);
              writeln('YES!');
              changetextcolor(lightcyan);
              fat_inf := true;
              END;
        END;  { t_sect[0] = char($eb) ... }
    END;  { fat[i] = bad_cluster and fat[i+1] = bad cluster ... }
END;

if not fat_inf then
   BEGIN
   writeln('NO!');
   END;

{ ******************************************************************** }

{ Now, to detect the virus via the directory sectors... }

write('Is the Directory infected? (Brain label present?). . . . . ');

read_dir(drive,dir);

dir_inf := false;
found := false;
i := 1; entry := 0;

while (i <= dir_sect_length[dtype]) and (not found) do
BEGIN
   find_brain (dir[i],found,entry);
   if found then
      dir_sector_where_found := i;
   i := i + 1;
END;

if found then
BEGIN
   dir_inf := true;
   changetextcolor(white+blink);
   writeln('YES!');
   changetextcolor(lightcyan);
END
else
   writeln('NO!');

{ ******************************************************************** }
{ Now, do the corrections to the disk... }
{ Outline for correcting the code...
      Is disk infected?
      No, skip over correction code.
      Yes, continue.
        Is Directory corrupted?
           Yes, over-write label in memory, and write it back
           No, continue
        Is Boot sector corrupted?
        Yes, continue
             Is FAT corrupted?
                Yes, get boot sector from first sector of virus code...
                No, get boot sector from other disk (user supplied DOS disk)
             Write boot sector.
        No, continue.
        Is FAT corrupted?
           Yes, fill in three clusters with nulls, write clusters to disk,
                and recover the three FAT entries, and write them back to disk.
           No, continue.
     END of correction code.
}

if boot_inf or fat_inf or dir_inf then  { if disk is infected...}
   BEGIN
   writeln;
   changetextcolor(lightmagenta);
   write('Disk is infected with the virus.  Do you wish to eradicate the virus? ');
   getkey(ch);
   writeln(ch);
   changetextcolor(yellow);
   if ch in ['Y'] then
      BEGIN
      if dir_inf then
         BEGIN
            dir[dir_sector_where_found][entry*32+0] := char($e5); { erased entry }
            for i := 1 to 11 do { fill name and attribute with spaces }
            BEGIN
               dir[dir_sector_where_found][entry*32+i] := ' ';
            END; { for i := 1 to 11 do }
         write_dir(drive,dir);
         END; { if dir_inf }

      if boot_inf then
         BEGIN
         if fat_inf then
            BEGIN
            read_absolute(drive, cluster_to_sector(first_bad_cluster), 1,
                          t_sect, disk_error[1], rom_error[1], dos_error[1]);
            if disk_error[1] then
               BEGIN
               changetextcolor(yellow+blink);
               writeln('Error reading virus sector (THIS SHOULD NOT APPEAR!)');
               changetextcolor(white);
               halt;
               END { if disk_error[1] }
            else
               BEGIN
               write_boot(drive, t_sect);
               END; {else }
            END { if disk_error[1] then }
         else
            BEGIN
            writeln(^G'Sorry about this, but I need you to insert a valid (uninfected)');
            writeln('DOS disk.  Place this disk in drive ',drvlett(drive),' and press');
            writeln('any key.');
            getkey(ch); writeln;
            read_boot(drive,t_sect);
            writeln; writeln('Please replace the infected disk in drive ',drvlett(drive));
            writeln('and press any key.');
            getkey(ch); writeln;
            write_boot(drive,t_sect);
            END; { if fat_inf }
          END;

      if fat_inf then
         BEGIN
         for i := 0 to 511 do
            BEGIN
            t_sect[i] := char(0); { fill the sector with nulls }
            END;
         for i := 0 to 5 do
            BEGIN
            write_absolute(drive,cluster_to_sector(first_bad_cluster)+i, 1,
                           t_sect, disk_error[1], rom_error[1], dos_error[1]);
            if disk_error[1] then
               BEGIN
               writeln('Error writing virus sector number ',i+1,' out of 6.');
               halt;
               END {if error[1] then }
         END; { for i := 0 to 5 do }
         { Now, fix the FAT "bad" entries }
         change_fat(first_bad_cluster,     0, fat, fat_org);
         change_fat(first_bad_cluster + 1, 0, fat, fat_org);
         change_fat(first_bad_cluster + 2, 0, fat, fat_org);
         { Now, copy the first fat table (0..1023) into the second fat table
           (1024..2047). }
         for i := 0 to 1023 do
            BEGIN
            fat_org[i+1024] := fat_org[i];
            END; { for i := 0 to 1023 do }

         write_fat(drive, fat_org);    { write the FAT back to disk }
      END; { if fat_inf then }
   writeln;
   writeln;         { THE VIRUS IS NOW DEAD!!!! }
   writeln ('Virus eradication is finished for this disk.');
END;
END;
END;
END.
